﻿local api = require "eu07.events"

api.event_create("onstart_lua", 0, 0, function(event, activator)
	-- tabela eventow ktore maja byc wywolane, jej celem jest mozliwosc ich "odwolania" w dowolnym momencie
	-- kolejkaEventow: {event, event, ...}
	-- event: {nazwaFunkcjiWLua, {parametr, parametr, ...}, opoznienie, {{zmienna, pozadanaWartosc}, {zmienna, pozadanaWartosc}, ...}}
	kolejkaEventow = {}
	-- zliczanie cykniec zegara
	tickZegara = 0
	-- dokladnosc zegara (mniej = wieksza dokladnosc, wiekszy spam w logu i mniejsze FPS, wiecej = mniejsza dokladnosc, mniej spamu w logu i mniejsze obciazenie)
	dokladnoscZegara = 0.5
	-- zegar - najwazniejsza jednostka calej symulacji, sluzy do eventow
	api.event_create("update", 0, 0, function(event, activator)
		api.event_dispatch_n("update", nil, dokladnoscZegara)
		kolejkaEventow_aktualizuj(dokladnoscZegara)
		tickZegara = tickZegara + 1
		printuj("[Event] Update (sekund: " .. tostring(tickZegara * dokladnoscZegara) .. ")")
	end)
	api.event_dispatch_n("update", nil, 0)
end)

-- inicjalizowanie wszystkiego
function inicjalizuj(dane)
	-- bedzie zabawa, bedzie sie dzialo... komentarzy tu nie bede robil :P
	for i = 1, #dane do
		local stacja = dane[i]
		local nazwaStacji = stacja[1]
		local skrotStacji = stacja[2]
		local typStacji = stacja[3]
		if typStacji == 0 then
			iStacja(nazwaStacji) -- szlak nie ma dyzurnego
		end
		local daneStacji = stacja[4]
		local izolacje = daneStacji[1]
		for j = 1, #izolacje do
			local izolacja = izolacje[j]
			iTor(nazwaObiektu(izolacja, nazwaStacji))
		end
		local zwrotnice = daneStacji[2]
		for j = 1, #zwrotnice do
			local zwrotnica = zwrotnice[j]
			iZwr(nazwaObiektu(zwrotnica, nazwaStacji))
		end
		local semafory = daneStacji[3]
		for j = 1, #semafory do
			local semafor = semafory[j]
			local nazwaSemafora = semafor[1]
			iSem(nazwaObiektu(nazwaSemafora, nazwaStacji))
			local zalSemafory = semafor[2]
			_G[nazwaObiektu(nazwaSemafora, nazwaStacji) .. "_zal"] = {}
			for k = 1, #zalSemafory do
				local zalSemafor = zalSemafory[k]
				table.insert(_G[nazwaObiektu(nazwaSemafora, nazwaStacji) .. "_zal"], nazwaObiektu(zalSemafor, nazwaStacji))
			end
			local powtarzacze = semafor[3]
			_G[nazwaObiektu(nazwaSemafora, nazwaStacji) .. "_powt"] = {}
			for k = 1, #powtarzacze do
				local powtarzacz = powtarzacze[k]
				table.insert(_G[nazwaObiektu(nazwaSemafora, nazwaStacji) .. "_powt"], nazwaObiektu(powtarzacz, nazwaStacji))
			end
			local przebiegi = semafor[4]
			_G[nazwaObiektu(nazwaSemafora, nazwaStacji) .. "_prz"] = {}
			for k = 1, #przebiegi do
				local przebieg = przebiegi[k]
				local nazwaPrzebiegu = przebieg[1]
				local predkosc = przebieg[2]
				local nastSemafor = nazwaObiektu(przebieg[3], nazwaStacji)
				local zwrotnice = przebieg[4]
				local listaZwrotnic = {}
				for l = 1, #zwrotnice do
					local zwrotnica = zwrotnice[l]
					table.insert(listaZwrotnic, nazwaObiektu(zwrotnica, nazwaStacji))
				end
				local izolacje = przebieg[5]
				local listaIzolacji = {}
				for l = 1, #izolacje do
					local izolacja = izolacje[l]
					table.insert(listaIzolacji, nazwaObiektu(izolacja, nazwaStacji))
				end
				table.insert(_G[nazwaObiektu(nazwaSemafora, nazwaStacji) .. "_prz"], {nazwaPrzebiegu, predkosc, nastSemafor, listaZwrotnic, listaIzolacji})
			end
		end
	end
end

function nazwaObiektu(nazwa, stacja)
	-- chodzi o to, ze jesli nazwa jest podana ze stacja, to zwraca ta nazwe z ta stacja, jesli nie ma podanej stacji, to ja dolacza
	local czyPasuje = true
	for i = 1, #nazwa do
		if string.sub(nazwa, i, i) == '_' then
			czyPasuje = false
			break
		end
	end
	-- wyjatek dla "null" by nie tworzyl np. "stacja1_null"
	if nazwa == "null" then
		czyPasuje = false
	end
	-- jesli nie znajdzie
	if czyPasuje then
		return stacja .. "_" .. nazwa
	end
	-- jesli znajdzie
	if not czyPasuje then
		return nazwa
	end
end

-- tory na stacjach (izolacje)
-- tworzymy dla kazdego toru eventy zmieniajace stan zmiennych
f_torZajety = api.event_preparefunc(function(event, activator)
	local tor = string.sub(api.event_getname(event), 1, -6)
	_G[tor .. "_zaj"] = 1
	printuj("[Tory] Zajeto izolacje " .. tor)
end)
f_torWolny = api.event_preparefunc(function(event, activator)
	local tor = string.sub(api.event_getname(event), 1, -6)
	_G[tor .. "_zaj"] = 0
	printuj("[Tory] Zwolniono izolacje " .. tor)
end)

-- funkcja inicjalizacyjna
function iTor(tor)
	-- tworzenie zmiennej (0 - wolny, 1 - zajety)
	_G[tor .. "_zaj"] = 0
	-- tworzenie podlaczen do izolacji
	api.event_create(tor .. ":busy", 0, 0, f_torZajety)
	api.event_create(tor .. ":free", 0, 0, f_torWolny)
	printuj("[Tory] Zainicjalizowano tor " .. tor)
end

-- zwrotnice
-- funkcja inicjalizacyjna
function iZwr(zwrotnica)
	-- zmienne stanu zwrotnic (0 - plus (wprost), 1 - minus (na bok))
	_G[zwrotnica .. "_stan"] = 0
	printuj("[Tory] Zainicjalizowano zwrotnice " .. zwrotnica)
end

-- semafory
-- tworzymy dla kazdego semafora polaczenia z eventami aby przy wygaszaniu semafora zauwazyly to zmienne i zmienily na 0
f_semaforWygas = api.event_preparefunc(function(event, activator)
	local semafor = string.sub(api.event_getname(event), 1, -4)
	_G[semafor .. "_sig"] = 0
	-- ... oraz zeby wykasowaly wszystkie eventy ktore maja zaswiecic ten semafor (zapobiega to podaniu semafora za pociagiem)
	kolejkaEventow_usun("zaswiecSemafor", {{semafor, 1}})
end)

-- funkcja inicjalizacyjna
function iSem(semafor)
	-- zmienne stanu semaforow (0 - stoj, 1 - vmax, 2 - 40, 3 - 60, 4 - 100, 5 - Sz, 6 - Ms1, 7 - Ms2)
	_G[semafor .. "_sig"] = 0
	api.event_create(semafor .. "_s1", 0, 0, f_semaforWygas)
	printuj("[Tory] Zainicjalizowano semafor " .. semafor)
end

-- stacje
-- funkcja inicjalizacyjna
function iStacja(stacja)
	-- pDyz = przymulenie dyzurnego, 0 = szybkosc swiatla, 60 = pijany jak ch*j
	_G["pDyz_" .. stacja] = api.random(0, 60)
	printuj("[Event] Zainicjalizowano stacje " .. stacja)
	printuj("[Event] Opoznienie stacji w sekundach (zaokraglone do 0.01): " .. tostring(round(_G["pDyz_" .. stacja], 2)))
end


--------------------------
-- KONIEC INICJALIZACJI --
--------------------------



function printuj(tekst)
	-- SEL = System Eventow LUA :)
	api.writelog("SEL v2.0 - LOG: " .. tekst)
end

function polaczEvent(event, polecenia)
	api.event_create(event, 0, 0, function(event, activator)
		for i = 1, #polecenia do
			local polecenie = polecenia[i]
			wykonajFunkcje(polecenie)
		end
	end)
	printuj("[Event] Utworzono event " .. event)
end

function czyZmiennePasuja(warunki)
	-- skladnia: {{zmienna1, wartosc1}, {zmienna2, wartosc2}, ...}
	local czyPasuje = true
	for i = 1, #warunki do
		local warunek = warunki[i]
		if _G[warunek[1]] ~= warunek[2] then
			czyPasuje = false
			break
		end
	end
	return czyPasuje
end

function kolejkaEventow_aktualizuj(delta)
	local iloscEventow = #kolejkaEventow
	-- Dla kazdego eventu w kolejce
	for i = 1, iloscEventow do
		-- iterujemy od tylu, bo jesli bysmy iterowali do przodu to w przypadku skasowania elementu nastepne elementy zmniejszaja ID o 1
		local j = iloscEventow - (i - 1)
		-- Zmniejsz opoznienie o delte (ale tylko wtedy gdy warunki sa spelnione)
		if czyZmiennePasuja(kolejkaEventow[j][4]) then
			kolejkaEventow[j][3] = kolejkaEventow[j][3] - delta
		end
		-- Jesli cale opoznienie zostalo juz wyczerpane (nadszedl czas wykonania polecenia) to wywolujemy ten event
		if kolejkaEventow[j][3] < 0 then
			kolejkaEventow_wykonaj(j)
		end
	end
end

function wykonajFunkcje(dane)
	-- dane TYLKO JEDNEJ FUNKCJI: {nazwaFunkcji, {parametr1, parametr2, parametr3, ...}}
	_G[dane[1]](unpack(dane[2]))
end

function kolejkaEventow_wykonaj(numer)
	-- Zapisujemy event ktory wykonujemy do zmiennej
	local event = kolejkaEventow[numer]
	-- Usuwamy event z kolejki
	table.remove(kolejkaEventow, numer)
	-- Wykonujemy funkcje w Lua
	wykonajFunkcje(event)
end

function kolejkaEventow_dodaj(dane)
	table.insert(kolejkaEventow, dane)
	printuj("[Event] Dodano do kolejki...")
	printuj("[Event] Nazwa: " .. dane[1])
	printuj("[Event] Parametry (" .. tostring(#dane[2]) .. "): ")
	for i = 1, #dane[2] do
		local parametr = dane[2][i]
		printuj("[Event] " .. tostring(i) .. ". " .. tostring(parametr))
	end
	printuj("[Event] Zostanie wykonane za sekund: " .. tostring(dane[3]))
	printuj("[Event] Dodatkowe warunki konieczne do wykonania (" .. tostring(#dane[4]) .. "): ")
	for i = 1, #dane[4] do
		local parametr = dane[4][i]
		printuj("[Event] " .. tostring(i) .. ". ")
		printuj("[Event] Zmienna: " .. tostring(parametr[1]))
		printuj("[Event] Wartosc: " .. tostring(parametr[2]))
	end
end

function kolejkaEventow_usun(nazwa, parametry)
	-- oba parametry moga nie istniec (jesli oba nie beda istnialy to de facto usuniemy wszystko z kolejki ;] )
	printuj("[Event] Rozpoczeto kasowanie... Kryteria:")
	printuj("[Event] Nazwa: " .. nazwa)
	printuj("[Event] Parametry (" .. tostring(#parametry) .. "): ")
	for i = 1, #parametry do
		local parametr = parametry[i]
		printuj("[Event] " .. tostring(i) .. ". ")
		printuj("[Event] Parametr: " .. parametr[1])
		printuj("[Event] Numer: " .. tostring(parametr[2]))
	end
	-- robimy to jak przy aktualizacji, pamietajac o tym ze iterujemy po eventach od tylu zeby nie zawalac struktury
	local iloscEventow = #kolejkaEventow
	-- Dla kazdego eventu w kolejce
	for i = 1, iloscEventow do
		local j = iloscEventow - (i - 1)
		-- Sprawdz czy warunki pasuja i jesli tak, to usun z kolejki
		if kolejkaEventow_czyPasuje(j, nazwa, parametry) then
			table.remove(kolejkaEventow, j)
			printuj("[Event] Skasowano event numer " .. tostring(j) .. "!")
		end
	end
end

function kolejkaEventow_czyPasuje(numer, nazwa, parametry)
	-- kolejkaEventow_czyPasuje(numerEventuKtorySprawdzamy, nazwaEventu (nil-able), {{parametr1, miejsceParametru1 (nil-able)}, {parametr2, miejsceParametru2 (nil-able)}, ...})
	-- zaczynamy od boola ktory bedzie wskazywal wynik, jesli nic nie zmieni go na false to bedzie true (zaliczony)
	local czyPasuje = true
	-- teraz tradycyjnie wyprowadzamy dane eventu ktore sprawdzamy
	local event = kolejkaEventow[numer]
	-- na poczatek, sprawdzamy nazwe (jesli nie ma nazwy to automatycznie przechodzimy dalej)
	if nazwa and nazwa ~= event[1] then
		czyPasuje = false
	end
	-- break point wydajnosciowy, jesli powyzszy test zostal oblany to nie ma sensu sprawdzac dalej i pomijamy reszte
	if not czyPasuje then
		return czyPasuje
	end
	-- jednak jesli sie upieklo to idziemy dalej, sprawdzamy liste parametrow (jesli istnieje!)
	if parametry then
		for i = 1, #parametry do
			-- wyciagamy parametr ktory sprawdzamy do zmiennej
			local parametr = parametry[i]
			-- dwa scenariusze, pierwszy: jesli mamy podany drugi parametr dla sprawdzenia parametrow - jego numer, to sprawdzamy ten konkretny parametr:
			if parametr[2] and parametr[1] ~= event[2][parametr[2]] then
				czyPasuje = false
			end
			-- drugi scenariusz, jesli nie mamy podanego konkretnego numeru parametru to iterujemy po wszystkich
			if not parametr[2] then
				local czyPasuje2 = false
				for j = 1, #event[2] do
					local parametr2 = event[2][j]
					if parametr[1] == parametr2 then
						czyPasuje2 = true
					end
				end
				czyPasuje = czyPasuje and czyPasuje2
			end
			-- kolejny break point
			if not czyPasuje then
				return czyPasuje
			end
		end
	end
	return czyPasuje
end

function podajPrzebieg(semafor, nazwa, opoznienie)
	-- Zwroc tablice zaleznosci semafora
	local tablicaPrzebiegow = _G[semafor .. "_prz"]
	-- Sprawdzamy kazdy przebieg w danym semaforze, czy pasuje nazwa
	for i = 1, #tablicaPrzebiegow do
		-- Zapisujemy dane o przebiegu do zmiennej
		local przebieg = _G[semafor .. "_prz"][i]
		-- Sprawdzamy czy nazwy przebiegow sie zgadzaja, jesli tak idziemy dalej
		if przebieg[1] == nazwa then
			-- Na poczatku musimy sprawdzic czy w ogole przebieg da sie ustawic, w tym celu sprawdzamy izolacje.
			local czyPasuje = true
			local izolacje = przebieg[5]
			for j = 1, #izolacje do
				local izolacja = izolacje[j]
				if _G[izolacja .. "_zaj"] == 1 then
					czyPasuje = false
					break
				end
			end
			-- Jezeli test oblany, to zaniechamy dalszej czesci i odkladamy na pozniej
			if not czyPasuje then
				local warunki = {}
				for j = 1, #izolacje do
					local izolacja = izolacje[j]
					table.insert(warunki, {izolacja .. "_zaj", 0})
				end
				kolejkaEventow_dodaj({"podajPrzebieg", {semafor, nazwa, opoznienie}, 0, warunki})
				break
			end
			-- Zrzucamy zwrotnice do zmiennej
			local zwrotnice = przebieg[4]
			-- Musimy ustawic kazda zwrotnice
			for j = 1, #zwrotnice do
				-- Kazda ze zwrotnic zapisujemy do zmiennej
				local zwrotnica = zwrotnice[j]
				-- Zwrotnice w zaleznosciach to np. "zwr01+", sa one dwuczlonowe, cala nazwa z wyjatkiem ostatniego znaku to nazwa zwrotnicy, zapisujemy ja
				local nazwaZwrotnicy = string.sub(zwrotnica, 1, -2)
				-- Reszte rowniez zapisujemy jako "+" (wprost) oraz "-" (w bok)
				local znakZwrotnicy = string.sub(zwrotnica, -1)
				-- Stan zwrotnicy musimy obliczyc bo polozenie zwrotnicy zapisywane jest jako 0 i 1, nie + i -, wiec konwertujemy
				local stanZwrotnicy = stanZwrotnicy(znakZwrotnicy)
				-- Teraz mozemy przelozyc zwrotnice
				_G[nazwaZwrotnicy .. "_stan"] = stanZwrotnicy
				-- i zaktualizowac jej stan.
				odswiezZwrotnice(nazwaZwrotnicy, opoznienie)
			end
			-- Na koniec pozostaje nam zaswiecenie semafora...
			_G[semafor .. "_sig"] = przebieg[2]
			-- i zaktualizowanie semafora tego i poprzedniego (jesli istnieje).
			odswiezSemafor(semafor, opoznienie)
			for j = 1, #_G[semafor .. "_zal"] do
				local zaleznySemafor = _G[semafor .. "_zal"][j]
				odswiezSemafor(zaleznySemafor, opoznienie + 0.5) -- dodajemy 0.5 zeby poprawnie wyswietlilo na koniec
			end
		end
	end
end

function genOpoznienie(stacja)
	-- sWyk = szybkosc wykonania polecenia
	local sWyk = api.random(0, 15)
	return sWyk + _G["pDyz_" .. stacja]
end

function odswiez(opoznienie)
	odswiezWszystkieZwrotnice(opoznienie)
	odswiezWszystkieSemafory(opoznienie)
end

function odswiezWszystkieZwrotnice(opoznienie)
	-- Dla kazdej zwrotnicy...
	for i = 1, #zwrotnice do
		-- Wpisz jej nazwe
		local zwrotnica = zwrotnice[i]
		-- I odswiez jej stan.
		odswiezZwrotnice(zwrotnica, opoznienie)
	end
end

function odswiezZwrotnice(zwrotnica, opoznienie)
	-- Odswieza stan zwrotnicy o podanej nazwie w terenie na podstawie tego co jest w kodzie.
	-- Zwroc jej stan
	local stanZwrotnicy = _G[zwrotnica .. "_stan"]
	-- I ustaw jej polozenie
	kolejkaEventow_dodaj({"przestawZwrotnice", {zwrotnica, stanZwrotnicy}, opoznienie, {}})
end

function przestawZwrotnice(zwrotnica, stan)
	api.event_dispatch_n(zwrotnica .. znakZwrotnicy(stan), activator, 0)
	printuj("[Tory] Przestawiono zwrotnice " .. zwrotnica .. " w polozenie " .. tostring(stan) .. " (" .. znakZwrotnicy(stan) .. ")")
end

function stanZwrotnicy(znak)
	if znak == "+" then return 0 end
	if znak == "-" then return 1 end
end

function znakZwrotnicy(stan)
	if stan == 0 then return "+" end
	if stan == 1 then return "-" end
end

function odswiezWszystkieSemafory(opoznienie)
	-- Dla kazdego semafora...
	for i = 1, #semafory do
		-- Wpisz jego nazwe do zmiennej.
		local semafor = semafory[i]
		-- I odswiez jego stan.
		odswiezSemafor(semafor, opoznienie)
	end
end

function odswiezSemafor(semafor, opoznienie)
	-- Odswieza stan semafora o podanej nazwie.
	-- Zwroc jego aktualny stan (wyswietlany sygnal)
	local tenSygnal = _G[semafor .. "_sig"]
	-- Deklaracja localu tutaj bo bedziemy go tutaj wykorzystywac a zmienimy jego wartosc glebiej
	local nastSygnal = 1
	-- Zwroc tablice zaleznosci semafora
	local tablicaPrzebiegow = _G[semafor .. "_prz"]
	-- I na kazdej z zaleznosci wykonaj ponizszy blok ktory sluzy do wyznaczenia jaki jest sygnal na nastepnym semaforze
	for i = 1, #tablicaPrzebiegow do
		-- Skopiujmy tablice zaleznosci
		local przebieg = _G[semafor .. "_prz"][i]
		-- Ustawmy bool, domyslnie jest na true, ale jesli pozniej cos mu sie nie spodoba to zmienimy na false
		local czyPasuje = true
		-- Teraz traktujemy kazdy przedmiot tej zaleznosci (kazda zwrotnice)
		local zwrotnice = przebieg[4]
		for j = 1, #zwrotnice do
			-- Kazda ze zwrotnic zapisujemy do zmiennej
			local zwrotnica = zwrotnice[j]
			-- Zwrotnice w zaleznosciach to np. "zwr01+", sa one dwuczlonowe, cala nazwa z wyjatkiem ostatniego znaku to nazwa zwrotnicy, zapisujemy ja
			local nazwaZwrotnicy = string.sub(zwrotnica, 1, -2)
			-- Reszte rowniez zapisujemy jako "+" (wprost) oraz "-" (w bok)
			local znakZwrotnicy = string.sub(zwrotnica, -1)
			-- Stan zwrotnicy musimy obliczyc bo polozenie zwrotnicy zapisywane jest jako 0 i 1, nie + i -, wiec konwertujemy
			local stanZwrotnicy = stanZwrotnicy(znakZwrotnicy)
			-- Teraz mozemy juz sprawdzic, jesli stan faktyczny nie pasuje z tym co mamy w zaleznosci to odrzucamy przebieg
			if _G[nazwaZwrotnicy .. "_stan"] ~= stanZwrotnicy then
				czyPasuje = false
				-- dalej robimy break, bo po co sprawdzac dalej cos co i tak nie przejdzie
				break
			end
		end
		-- Jesli wszystko pasuje to zmieniamy dane o nastepnym semaforze
		if czyPasuje then
			-- Wpisujemy to do zmiennej
			local nastSemafor = przebieg[3]
			-- i sprawdzamy, jesli nie jest zdeklarowany (wyjazd na szlak bez SBL) to po prostu dajemy tam zielone
			if nastSemafor == "null" then
				nastSygnal = 1
			end
			-- A jesli jest, to po prostu kopiujemy z niego dane
			if nastSemafor ~= "null" then
				nastSygnal = _G[nastSemafor .. "_sig"]
			end
		end
	end
	-- Ponizej jest drabinka ze wszystkimi mozliwymi sygnalami, zapalamy w zaleznosci od wartosci zmiennych
	-- Domyslnie Sz :)
	local sygnal = "sz1"
	if tenSygnal == 0 then sygnal = "s1" end
	if tenSygnal == 1 and (nastSygnal == 0 or nastSygnal > 4) then sygnal = "s5" end
	if tenSygnal == 1 and nastSygnal == 1 then sygnal = "s2" end
	if tenSygnal == 1 and (nastSygnal == 2 or nastSygnal == 3) then sygnal = "s4" end
	if tenSygnal == 1 and nastSygnal == 4 then sygnal = "s3" end
	if tenSygnal == 2 and (nastSygnal == 0 or nastSygnal > 4) then sygnal = "s13" end
	if tenSygnal == 2 and nastSygnal == 1 then sygnal = "s10" end
	if tenSygnal == 2 and (nastSygnal == 2 or nastSygnal == 3) then sygnal = "s12" end
	if tenSygnal == 2 and nastSygnal == 4 then sygnal = "s11" end
	if tenSygnal == 3 and (nastSygnal == 0 or nastSygnal > 4) then sygnal = "s13a" end
	if tenSygnal == 3 and nastSygnal == 1 then sygnal = "s10a" end
	if tenSygnal == 3 and (nastSygnal == 2 or nastSygnal == 3) then sygnal = "s12a" end
	if tenSygnal == 3 and nastSygnal == 4 then sygnal = "s11a" end
	if tenSygnal == 4 and (nastSygnal == 0 or nastSygnal > 4) then sygnal = "s9" end
	if tenSygnal == 4 and nastSygnal == 1 then sygnal = "s6" end
	if tenSygnal == 4 and (nastSygnal == 2 or nastSygnal == 3) then sygnal = "s8" end
	if tenSygnal == 4 and nastSygnal == 4 then sygnal = "s7" end
	if tenSygnal == 5 then sygnal = "sz1" end
	if tenSygnal == 6 then sygnal = "ms1" end
	if tenSygnal == 7 then sygnal = "ms2" end
	kolejkaEventow_dodaj({"zaswiecSemafor", {semafor, sygnal}, opoznienie, {}})
	-- Jeszcze wypadaloby podac powtarzacze...
	-- Na poczatek musimy zrzucic te dane do zmiennej.
	local powtarzacze = _G[semafor .. "_powt"]
	-- Teraz BARDZO WAZNE!!! Musimy sprawdzic czy ta lista istnieje, gdyz jesli niczego nie bedzie (a chcemy z tym zrobic foreach) to bedzie crash!
	if powtarzacze ~= nil then
		-- Teraz zaswiecamy na kazdym z powtarzaczy sygnal.
		for i = 1, #powtarzacze do
			-- Zrzucamy nazwe powtarzacza do zmiennej...
			local powtarzacz = powtarzacze[i]
			-- i lecimy!
			local sygnal = "sp1"
			if tenSygnal == 0 or tenSygnal > 4 then sygnal = "sp1" end
			if tenSygnal == 1 then sygnal = "sp2" end
			if tenSygnal == 2 or tenSygnal == 3 then sygnal = "sp4" end
			if tenSygnal == 4 then sygnal = "sp3" end
			kolejkaEventow_dodaj({"zaswiecSemafor", {powtarzacz, sygnal}, opoznienie, {}})
		end
	end
end

function zaswiecSemafor(semafor, sygnal)
	api.event_dispatch_n(semafor .. "_" .. sygnal, activator, 0)
	printuj("[Tory] Zapalono sygnal " .. sygnal .. " na semaforze " .. semafor)
end

function randomBool()
	local los = api.random(0, 2)
	if los < 1 then return false end
	if los >= 1 then return true end
end

function round(num, numDecimalPlaces)
  local mult = 10^(numDecimalPlaces or 0)
  return math.floor(num * mult + 0.5) / mult
end